/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <bld/listop.h>
#include <bld/interp.h>

/***********************************************************************
class BLD_ForEachOperation
***********************************************************************/
BLD_Value BLD_ForEachOperation::Perform(void) const
{
	// Determine the list of values over which to range.
	BLD_Value list;
	if (!range.IsNull())
	{
		list = range->Perform();
	}

	// For each subsidiary value...
	BLD_Value value;
	register const unsigned long n = list.GetCount();
	for (register unsigned long i = 0; n > i; ++i)
	{
		// Update the named variable with the value.
		BLD_CONTEXT.SetValue(name, list[i]);

		// Perform the block of operations.
		value = BLD_BlockOperation::Perform();
	}
	// Return the last value produced by the block.
	return value;
}

GPL_String BLD_ForEachOperation::ToString(void) const
{
	GPL_String image;
	image.Append("foreach ");
	image.Append(name);
	image.Append(" (");
	if (!range.IsNull())
	{
		image.Append(range->ToString());
	}
	image.Append(")");
	image.Join("\n", "{");
	image.Join("\n", BLD_BlockOperation::ToString());
	image.Join("\n", "}");
	return image;
}
