#ifndef BLD_PRAGMAOP_H
#define BLD_PRAGMAOP_H

/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <bld/op.h>

/***********************************************************************
class BLD_PragmaOperation

Generic pragma operation.
***********************************************************************/
class BLD_PragmaOperation : public BLD_Operation
{
	public:
		BLD_PragmaOperation(void) {}
		virtual ~BLD_PragmaOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;
};

/***********************************************************************
class BLD_PragmaDumpOperation

State dump operation.
***********************************************************************/
class BLD_PragmaDumpOperation : public BLD_PragmaOperation
{
	public:
		BLD_PragmaDumpOperation(const GPL_Boolean d = FALSE) {}
		virtual ~BLD_PragmaDumpOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;

	protected:
		GPL_Boolean dumpTopOnly;
};

/***********************************************************************
class BLD_PragmaEnvOperation

Environment dump operation.
***********************************************************************/
class BLD_PragmaEnvOperation : public BLD_PragmaOperation
{
	public:
		BLD_PragmaEnvOperation(void) {}
		virtual ~BLD_PragmaEnvOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;
};

#endif /* BLD_PRAGMAOP_H */
