#ifndef BLD_VALUE_H
#define BLD_VALUE_H

/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

#include <gpl/gpl.h>

/***********************************************************************
class BLD_Value

Abstract base class for all values.
***********************************************************************/
class BLD_Value : public GPL_Array<GPL_String>
{
	public:
		static const GPL_String falsehood;
		static const GPL_String truth;
		static GPL_RegularExpression numericDataPattern;

		BLD_Value(void) {}
		BLD_Value(const GPL_String & s) { Resize(1); AppendElement(s); }
		BLD_Value(const GPL_Array<GPL_String> & a) : GPL_Array<GPL_String>(a) {}
		virtual ~BLD_Value(void) {}

		GPL_Boolean operator==(const BLD_Value & value) const { return 0 == Compare(value); }
		GPL_Boolean operator!=(const BLD_Value & value) const { return 0 != Compare(value); }
		GPL_Boolean operator<(const BLD_Value & value) const { return 0 < Compare(value); }
		GPL_Boolean operator<=(const BLD_Value & value) const { return 0 <= Compare(value); }
		GPL_Boolean operator>(const BLD_Value & value) const { return 0 > Compare(value); }
		GPL_Boolean operator>=(const BLD_Value & value) const { return 0 >= Compare(value); }

		GPL_String GetString(void) const;
		virtual GPL_Boolean IsFalse(void) const;

	protected:
		long Compare(const BLD_Value & value) const;
};

#endif /* BLD_VALUE_H */
